searchData={"items":[{"type":"module","title":"BrowserForge","doc":"Documentation for `BrowserForge`.","ref":"BrowserForge.html"},{"type":"function","title":"BrowserForge.hello/0","doc":"Hello world.","ref":"BrowserForge.html#hello/0"},{"type":"function","title":"Examples - BrowserForge.hello/0","doc":"iex> BrowserForge.hello()\n    :world","ref":"BrowserForge.html#hello/0-examples"},{"type":"module","title":"BrowserForge.BayesianNetwork","doc":"Implementation of a bayesian network capable of randomly sampling from its distribution.","ref":"BrowserForge.BayesianNetwork.html"},{"type":"function","title":"BrowserForge.BayesianNetwork.generate_consistent_sample_when_possible/2","doc":"Randomly samples values from the distribution represented by the bayesian network,\nmaking sure the sample is consistent with the provided restrictions on value possibilities.\nReturns nil if no such sample can be generated.","ref":"BrowserForge.BayesianNetwork.html#generate_consistent_sample_when_possible/2"},{"type":"function","title":"BrowserForge.BayesianNetwork.generate_sample/2","doc":"Randomly samples from the distribution represented by the bayesian network.","ref":"BrowserForge.BayesianNetwork.html#generate_sample/2"},{"type":"function","title":"BrowserForge.BayesianNetwork.get_possible_values/2","doc":"Given a network instance and a set of user constraints, returns an extended\nset of constraints induced by the original constraints and network structure.","ref":"BrowserForge.BayesianNetwork.html#get_possible_values/2"},{"type":"function","title":"BrowserForge.BayesianNetwork.new/1","doc":"","ref":"BrowserForge.BayesianNetwork.html#new/1"},{"type":"type","title":"BrowserForge.BayesianNetwork.t/0","doc":"","ref":"BrowserForge.BayesianNetwork.html#t:t/0"},{"type":"module","title":"BrowserForge.BayesianNode","doc":"Implementation of a single node in a bayesian network allowing sampling from its conditional distribution.","ref":"BrowserForge.BayesianNode.html"},{"type":"function","title":"BrowserForge.BayesianNode.get_probabilities_given_known_values/2","doc":"Extracts unconditional probabilities of node values given the values of the parent nodes.","ref":"BrowserForge.BayesianNode.html#get_probabilities_given_known_values/2"},{"type":"function","title":"BrowserForge.BayesianNode.name/1","doc":"Gets the name of the node.","ref":"BrowserForge.BayesianNode.html#name/1"},{"type":"function","title":"BrowserForge.BayesianNode.new/1","doc":"","ref":"BrowserForge.BayesianNode.html#new/1"},{"type":"function","title":"BrowserForge.BayesianNode.parent_names/1","doc":"Gets the parent names of the node.","ref":"BrowserForge.BayesianNode.html#parent_names/1"},{"type":"function","title":"BrowserForge.BayesianNode.possible_values/1","doc":"Gets the possible values of the node.","ref":"BrowserForge.BayesianNode.html#possible_values/1"},{"type":"function","title":"BrowserForge.BayesianNode.sample/2","doc":"Randomly samples from the conditional distribution of this node given values of parents.","ref":"BrowserForge.BayesianNode.html#sample/2"},{"type":"function","title":"BrowserForge.BayesianNode.sample_according_to_restrictions/4","doc":"Randomly samples from the conditional distribution of this node given restrictions on the possible values and the values of the parents.","ref":"BrowserForge.BayesianNode.html#sample_according_to_restrictions/4"},{"type":"function","title":"BrowserForge.BayesianNode.sample_random_value_from_possibilities/2","doc":"Randomly samples from the given values using the given probabilities.","ref":"BrowserForge.BayesianNode.html#sample_random_value_from_possibilities/2"},{"type":"type","title":"BrowserForge.BayesianNode.t/0","doc":"","ref":"BrowserForge.BayesianNode.html#t:t/0"},{"type":"module","title":"BrowserForge.Download","doc":"Downloads the required model definitions","ref":"BrowserForge.Download.html"},{"type":"function","title":"BrowserForge.Download.download/1","doc":"Downloads the required data files based on the provided options.","ref":"BrowserForge.Download.html#download/1"},{"type":"function","title":"BrowserForge.Download.download_if_not_exists/1","doc":"Downloads files if they don't exist.","ref":"BrowserForge.Download.html#download_if_not_exists/1"},{"type":"function","title":"BrowserForge.Download.downloaded?/1","doc":"Checks if the required data files are already downloaded.","ref":"BrowserForge.Download.html#downloaded?/1"},{"type":"function","title":"BrowserForge.Download.remove/0","doc":"Removes all downloaded data files.","ref":"BrowserForge.Download.html#remove/0"},{"type":"module","title":"BrowserForge.Headers.Browser","doc":"Represents a browser specification with name, min/max version, and HTTP version.","ref":"BrowserForge.Headers.Browser.html"},{"type":"function","title":"BrowserForge.Headers.Browser.new/2","doc":"Creates a new Browser struct with the given options.","ref":"BrowserForge.Headers.Browser.html#new/2"},{"type":"function","title":"Options - BrowserForge.Headers.Browser.new/2","doc":"* `:name` - The browser name (required)\n  * `:min_version` - Minimum browser version (optional)\n  * `:max_version` - Maximum browser version (optional)\n  * `:http_version` - HTTP version to use, defaults to \"2\" (optional)","ref":"BrowserForge.Headers.Browser.html#new/2-options"},{"type":"function","title":"Examples - BrowserForge.Headers.Browser.new/2","doc":"iex> Browser.new(\"chrome\")\n    %Browser{name: \"chrome\", http_version: \"2\"}\n\n    iex> Browser.new(\"firefox\", min_version: 100, max_version: 110)\n    %Browser{name: \"firefox\", min_version: 100, max_version: 110, http_version: \"2\"}","ref":"BrowserForge.Headers.Browser.html#new/2-examples"},{"type":"type","title":"BrowserForge.Headers.Browser.t/0","doc":"","ref":"BrowserForge.Headers.Browser.html#t:t/0"},{"type":"module","title":"BrowserForge.Headers.Generator","doc":"Generates HTTP headers based on a set of constraints.","ref":"BrowserForge.Headers.Generator.html"},{"type":"function","title":"BrowserForge.Headers.Generator.generate/2","doc":"Generates headers using the default options and their possible overrides.","ref":"BrowserForge.Headers.Generator.html#generate/2"},{"type":"function","title":"Options - BrowserForge.Headers.Generator.generate/2","doc":"* `:browser` - Browser(s) or Browser struct(s) to generate headers for\n  * `:os` - Operating system(s) to generate headers for\n  * `:device` - Device(s) to generate headers for\n  * `:locale` - Language(s) for the Accept-Language header\n  * `:http_version` - HTTP version to use (1 or 2)\n  * `:user_agent` - User-Agent(s) to use\n  * `:request_dependent_headers` - Known values of request-dependent headers\n  * `:strict` - Whether to throw an error if headers cannot be generated","ref":"BrowserForge.Headers.Generator.html#generate/2-options"},{"type":"function","title":"Examples - BrowserForge.Headers.Generator.generate/2","doc":"iex> generator = Generator.new()\n    iex> Generator.generate(generator)\n    %{\"User-Agent\" => \"...\", ...}\n\n    iex> Generator.generate(generator, browser: \"chrome\", os: \"windows\")\n    %{\"User-Agent\" => \"...\", ...}","ref":"BrowserForge.Headers.Generator.html#generate/2-examples"},{"type":"function","title":"BrowserForge.Headers.Generator.new/1","doc":"Creates a new HeaderGenerator with the given options.","ref":"BrowserForge.Headers.Generator.html#new/1"},{"type":"function","title":"Options - BrowserForge.Headers.Generator.new/1","doc":"* `:browser` - Browser(s) or Browser struct(s) to generate headers for\n  * `:os` - Operating system(s) to generate headers for\n  * `:device` - Device(s) to generate headers for\n  * `:locale` - Language(s) for the Accept-Language header\n  * `:http_version` - HTTP version to use (1 or 2)\n  * `:strict` - Whether to throw an error if headers cannot be generated","ref":"BrowserForge.Headers.Generator.html#new/1-options"},{"type":"function","title":"Examples - BrowserForge.Headers.Generator.new/1","doc":"iex> Generator.new()\n    %Generator{}\n\n    iex> Generator.new(browser: \"chrome\", os: \"windows\", device: \"desktop\")\n    %Generator{}","ref":"BrowserForge.Headers.Generator.html#new/1-examples"},{"type":"type","title":"BrowserForge.Headers.Generator.browser_option/0","doc":"","ref":"BrowserForge.Headers.Generator.html#t:browser_option/0"},{"type":"type","title":"BrowserForge.Headers.Generator.list_or_string/0","doc":"","ref":"BrowserForge.Headers.Generator.html#t:list_or_string/0"},{"type":"type","title":"BrowserForge.Headers.Generator.t/0","doc":"","ref":"BrowserForge.Headers.Generator.html#t:t/0"},{"type":"module","title":"BrowserForge.Headers.HttpBrowserObject","doc":"Represents a browser object with HTTP version information.","ref":"BrowserForge.Headers.HttpBrowserObject.html"},{"type":"function","title":"BrowserForge.Headers.HttpBrowserObject.is_http2/1","doc":"Returns true if the browser object is using HTTP/2, false otherwise.","ref":"BrowserForge.Headers.HttpBrowserObject.html#is_http2/1"},{"type":"module","title":"BrowserForge.Headers.Utils","doc":"Utility functions for header generation.","ref":"BrowserForge.Headers.Utils.html"},{"type":"function","title":"BrowserForge.Headers.Utils.get_browser/1","doc":"Determines the browser name from the User-Agent string.","ref":"BrowserForge.Headers.Utils.html#get_browser/1"},{"type":"function","title":"BrowserForge.Headers.Utils.get_user_agent/1","doc":"Retrieves the User-Agent from the headers dictionary.","ref":"BrowserForge.Headers.Utils.html#get_user_agent/1"},{"type":"function","title":"BrowserForge.Headers.Utils.pascalize/1","doc":"Converts a header name to Pascal case.","ref":"BrowserForge.Headers.Utils.html#pascalize/1"},{"type":"function","title":"BrowserForge.Headers.Utils.pascalize_headers/1","doc":"Converts all header names in a map to Pascal case.","ref":"BrowserForge.Headers.Utils.html#pascalize_headers/1"},{"type":"function","title":"BrowserForge.Headers.Utils.tuplify/1","doc":"Converts a value to a tuple if it's not already an enumerable.","ref":"BrowserForge.Headers.Utils.html#tuplify/1"},{"type":"task","title":"mix browserforge.download_test_data","doc":"","ref":"Mix.Tasks.Browserforge.DownloadTestData.html"},{"type":"function","title":"Mix.Tasks.Browserforge.DownloadTestData.run/1","doc":"","ref":"Mix.Tasks.Browserforge.DownloadTestData.html#run/1"},{"type":"extras","title":"BrowserForge.ex","doc":"BrowserForge.ex\n \n\n \n    🎭 Intelligent browser header & fingerprint generator for Elixir\n \n\n---","ref":"readme.html"},{"type":"extras","title":"What is it? - BrowserForge.ex","doc":"BrowserForge.ex is an Elixir implementation of browser header and fingerprint generation that mimics the frequency of different browsers, operating systems, and devices found in the wild.","ref":"readme.html#what-is-it"},{"type":"extras","title":"Features - BrowserForge.ex","doc":"- Uses a Bayesian generative network to mimic actual web traffic\n- Fast runtime performance\n- Simple API design\n- Extensive customization options\n- Type safety with typespecs","ref":"readme.html#features"},{"type":"extras","title":"Installation - BrowserForge.ex","doc":"Add to your mix.exs:\n```elixir\ndef deps do\n  [\n    {:browserforge, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - BrowserForge.ex","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Generating Headers - BrowserForge.ex","doc":"```elixir\ngenerator = BrowserForge.Headers.Generator.new\nheaders = BrowserForge.Headers.Generator.generate(generator)\n```","ref":"readme.html#generating-headers"},{"type":"extras","title":"Documentation - BrowserForge.ex","doc":"Full documentation can be found at [https://hexdocs.pm/browserforge](https://hexdocs.pm/browserforge)","ref":"readme.html#documentation"},{"type":"extras","title":"License - BrowserForge.ex","doc":"Licensed under the Apache License, Version 2.0. See [LICENSE](LICENSE) for details.\n\n---","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}